<!-- eslint-disable vue/multi-word-component-names -->
<template>
  <div class="d-flex flex-column align-items-center">
    <div class="d-flex form-container">
      <div class="registration-form p-4 border rounded shadow">
        <h1>Login</h1>
        <b-alert
          v-if="$route.query.reason && $route.query.reason === 'inactivity'"
          class="mb-3"
          dismissible
          show
          variant="warning"
        >
          You have been logged out due to inactivity.
        </b-alert>
        <b-form @submit.prevent="login">
          <b-form-group label="Username">
            <b-form-input
              v-model="username"
              :disabled="submitting"
              placeholder="Enter your username"
            />
          </b-form-group>
          <b-form-group label="Password">
            <b-form-input
              v-model="password"
              placeholder="Enter your password"
              type="password"
            />
          </b-form-group>
          <b-alert
            :show="showError"
            variant="danger"
          >
            {{ errorMessage }}
          </b-alert>
          <hr>
          <b-button
            :disabled="$v.$invalid || submitting"
            block
            type="submit"
            variant="success"
          >
            Login
          </b-button>
          <b-button
            :disabled="submitting"
            :to="{ name: 'register', query: $route.query }"
            block
            class="mb-2"
            variant="primary"
          >
            Need an account?
          </b-button>
          <b-link :to="{ name: 'forgotPassword' }">
            Forgot your Password?
          </b-link>
        </b-form>
      </div>
    </div>
  </div>
</template>

<script lang="ts">
/* eslint-disable no-alert */
import Vue from 'vue';
import { required } from 'vuelidate/lib/validators';

import { LOGIN } from '@/store/actions';

export default Vue.extend({

  beforeRouteLeave(to, from, next) {
    if (this.$v.$anyDirty && !this.submitted) {
      const confirmed = window.confirm('You have unsaved changes, do you really want to leave?');
      if (confirmed) {
        next();
      }
      return;
    }
    next();
  },
  data() {
    return {
      errorMessage: '',
      submitted: false,
      showError: false,
      submitting: false,
      password: '',
      username: '',
    };
  },

  validations: {
    password: { required },
    username: { required },
  },

  methods: {
    async login() {
      this.submitting = true;
      try {
        await this.$store.dispatch(LOGIN, {
          username: this.username,
          password: this.password,
        });
        this.submitting = false;
        this.submitted = true;
        this.$router.push(<string> this.$route.query.redirect || { name: 'locusList' });
      } catch (error) {
        this.errorMessage = error;
        this.showError = true;
        this.submitting = false;
      }
    },
  },
});
</script>

<style scoped>
.form-container {
  margin-top: 70px;
}
.registration-description {
  margin-right: 1em;
}
.registration-description {
  font-family: Arial, Helvetica, sans-serif;
  font-weight: bolder;
  font-variant: small-caps;
  font-size: 4em;
  color: darkslategray;
}
.registration-form {
  width: 400px;
}
</style>
